#  This is a test Ratfor program to be translated to Fortran 66.
#  Convert (on MUSIC/SP) by:  rat4.test  (Output file is ttrat4out)
#  On the PC:  rat4.exe -o outputfile < rat4_test.r
#
#  WARNING: Ratfor is really a different language from Fortran.
#    It is not just a utility for converting one dialect of Fortran
#    to another. It also has some incorrect behaviour when dealing
#    with IBM Fortran (see below).
#
#  This test shows some of the features of Ratfor, including:
#  - Use of # for comments.
#    C or c comments should not be used.
#  - Grouping of statements by braces { }.
#  - Use of == >= != etc. for comparison.
#  - Use of alternate base (2 to 36) in integer constants: b%m
#    For example: 2%101 is 5, 16%1f is 31, 36%1z is 71.
#  - Use of mixed case. HOWEVER, Ratfor converts everything (except
#    string constants) to lower case. Therefore it is best to keep
#    everything in lower case (except string constants).
#      Note: You can use the FORTPREP utility to convert non-string
#            Ratfor output source to upper case. See $pgm:fortprep.txt
#
#  NOT handled correctly by Ratfor:
#  - Alternate-return statement numbers &n in CALL: Ratfor changes
#    the & to .and.  The VS Fortran form *n is handled ok.
#  - return n statement (alternate return): generates =n / return
#    (Ratfor treats return n or return(n) as specifying the function
#    return value.
#
#  F77 version of Ratfor:
#  If the source file rat4.c is compiled with macro F77 defined,
#  then extra coding in included to generate Fortran source that
#  uses if-then-else structured programming statements (Fortran 77
#  level) instead of if-goto statements. Source file rat4_f77.c
#  does this - same as rat4.c except it defines F77. To convert
#  this test source file using that version, run rat4_f77.test .
#
      implicit integer(a-z)
      integer num1,num2,n1
#-----
      n1=2%101   # Alternate base: this is equivalent to n1=5
      n1=16%1f
      n1=16%FF
      n1=36%1z
      n1=30%Bk   # same as n1=350  (11*30 + 20)
      do ii=1,999   # this is a comment
      {
      write(6,11)
11    format('Enter an integer value')
# ** Ratfor converts &n (alternate return) to .and.n :
      call rdint(num1,9,&12,&13)
17    WRITE(6,14)
14    FORMAT('Enter a second integer value')
      call rdint(num2,9,&15,&13)
      go to 20
12    write(6,16)
16    format('** Invalid value, try again')
      next
15    write(6,16)
      go to 17
13    stop 1
#
20    write(6,21) num1,num2
21    format('Values entered: ',2i12)
#
      if(num1==1) {
         write(6,31)
31       format('  num1 is 1')
        }
      else
        {
         write(6,32)
32       format('  num1 is not 1')
        }
#
      if(num2>=3)
        {
         write(6,33)
33       format('  num2 is 3 or more')
        }
#
      if(num2==11) {
         write(6,41)
41       format('  num2 is 11')
        }
      else if(num2.eq.12) {
         write(6,42)
42       format('  num2 is 12')
        }
      else {
         write(6,43)
43       format('  num2 is not 11 or 12')
        }
#
      }
      stop 2
      end
#-------------------------------
      subroutine rdint(num,unit,*,*)
#  Read an integer (1 to 9 digits, with optional "-") in free format.
#  Alternate return 1 if error, alternate return 2 if end-of-file.
      implicit integer(a-z)
      integer num,unit,n1,n2,sign,ln,locate
      logical equal
      logical*1 b(25)
      integer sizeb/25/
#-----
      read(unit,12,end=14) b
12    format(80a1)
      n1=ln(b,sizeb)
      if(n1.eq.0) go to 13
      n2=locate(b,n1,' ',-1)
      sign=1
      if(.not.(n2.lt.n1 .and. equal(b(n2),'-',1))) go to 15
         sign=-1
         n2=n2+1
15    continue
# ** Ratfor converts &n (alternate return) to .and.n :
      call decin(b(n2),n1-n2+1,num,&13)
      if(sign.lt.0) num=-num
      return
#  error:
13    num=-99999
# ** return n is not handled by Ratfor:
      RETURN 1
14    num=-99999
      return 2
      end
