/* Characters (Ascii or EBCDIC) */
#define NEWLINE '\n'    /* Ascii x'0A', EBCDIC x'15' */
#define TAB     '\t'    /* Ascii x'09', EBCDIC x'05' */
#define BLANK   ' '
#define DIG0    '0'
#define DIG9    '9'
#define BIGA    'A'
#define BIGI    'I'
#define BIGJ    'J'
#define BIGR    'R'
#define BIGS    'S'
#define BIGZ    'Z'
#define LETA    'a'
#define LETB    'b'
#define LETC    'c'
#define LETD    'd'
#define LETE    'e'
#define LETF    'f'
#define LETG    'g'
#define LETH    'h'
#define LETI    'i'
#define LETJ    'j'
#define LETK    'k'
#define LETL    'l'
#define LETM    'm'
#define LETN    'n'
#define LETO    'o'
#define LETP    'p'
#define LETQ    'q'
#define LETR    'r'
#define LETS    's'
#define LETT    't'
#define LETU    'u'
#define LETV    'v'
#define LETW    'w'
#define LETX    'x'
#define LETY    'y'
#define LETZ    'z'
#define AND     '&'
#define ATSIGN  '@'
#define ESCAPE  ATSIGN
#define BACKSLASH  '\\'
#define BANG    '!'
#define BAR     '|'
#define OR      BAR
#define CARET   '^'
#define COLON   ':'
#define COMMA   ','
#define DOLLAR  '$'
#define DQUOTE  '"'
#define EQUALS  '='
#define GREATER '>'
#define LBRACE  '{'
#define LBRACK  '['
#define LESS    '<'
#define LPAREN  '('
#define MINUS   '-'
#define TILDE   '~'
#define NOT     '~'
#define PERCENT '%'
#define PERIOD  '.'
#define PLUS    '+'
#define QMARK   '?'
#define RBRACE  '}'
#define RBRACK  ']'
#define RPAREN  ')'
#define SEMICOL ';'
#define SHARP   '#'
#define SLASH   '/'
#define SQUOTE  '\''
#define STAR    '*'
#define UNDERLINE  '_'

#define EOFCH   0xFF               /* EOF char, added by *DE* */

#define HUGE    30000
#define NO      0
#define YES     1
#define EOS     0     /* end of string */

/*** Not used (*DE*) :
#define LIMIT   134217728
#define LIM1    28
#define LIM2    -28   ***/

/*
 * lexical analyser symbols
 *
 */

#define LETTER          1
#define DIGIT           2
#define ALPHA           3
#define LEXBREAK        4
#define LEXDIGITS       5
#define LEXDO           6
#define LEXELSE         7
#define LEXFOR          8
#define LEXIF           9
#define LEXNEXT         10
#define LEXOTHER        11
#define LEXREPEAT       12
#define LEXUNTIL        13
#define LEXWHILE        14
#define LEXRETURN       15
#define LEXEND          16
#define LEXSTOP         17
#define LEXSTRING       18
#define LEXSWITCH       19
#define LEXCASE         20
#define LEXDEFAULT      21
#define DEFTYPE         22

#define MAXCHARS        10      /* characters for outnum */
#define MAXDEF          200     /* max chars in a defn */
#define MAXSWITCH       300     /* max stack for switch statement */
#define CUTOFF          3     /* min number of cases necessary to generate */
                                /* a dispatch table */
#define DENSITY         2
#define MAXFORSTK       200     /* max space for for reinit clauses */
#define MAXFNAMES       350     /* max chars in filename stack NFILES*MAXNAME */
#define MAXNAME         64      /* file name size in gettok */
#define MAXSTACK        100     /* max stack depth for parser */
#define MAXTBL          15000   /* max chars in all definitions */
#define MAXTOK          132     /* max chars in a token */
#define NFILES          7       /* max depth of file inclusion */

#define RADIX           PERCENT /* % indicates alternate radix */
#define BUFSIZE         300     /* pushback buffer for ngetch and putbak */

